#ifndef MANAGER_H
#define MANAGER_H

#include <list>
#include "command.h"

class Thing;

/** \class Manager
        \brief Klasse welche alle Thingobjekte verwaltet.

        Der Manager verwaltet alle im Spiel enthaltenen Thing Objekte anhand ihrer id und vermittelt Kommandos die sie sich gegenseitig
        Schicken.
*/
class Manager
{
public:
    /** \fn Manager()
            \brief Macht eigentlich nicht so viel...
    */
    Manager();

    /** \fn void execute(std::list<Instruction> * pInst)
            \brief Fhre einen Befehl entweder selbst aus oder leitet ihn an ein Objekt weiter.

            Und das hier ist noch eine laaaaaaaaaaaaaaaaaaaaaaaaaaaange Beschreibung der Funktion
            welche allerdings nur Testzwecken dient und daher keine Informationen enthlt.
             haha umlaute funktionieren!!! :)

            \param pInst ist ein pointer auf eine Liste von Instruktionen die der Manager an
                    Thingobjekte weiterzuleiten oder selbst auszufhren hat.
    */
    void execute(std::list<Instruction> * pInst);

    //void execute(Liste von Commands);
    /**
      \fn void add(Thing *pt)
        \param pt Is the pointer to a just allocated Object of Type Thing
      */

    void add(Thing*pt); //Fgt Thing Object auf das pt zeigt an das Thingarray an.

    void deleteThing(int id); //Sucht das Objekt mit der id und lscht es.

    Thing *get(int id);
    //Sucht das Objekt mit der bergebenen id aus dem thingarray heraus, und gibt den pointer darauf zurck.
    //Wenn es keins findet dann wird ein pointer auf ein spezielles dummy element zurckgegeben.


private:
    /** \var static const int id
          \brief Der Manager hat immer die ID 1.
      */
    static const int id = 1; //Der Manager hat die id 1. Kein anderes Thing Objekt darf die id 1 haben.

    std::list<Thing*> ThingList; //Liste von Things im Spiel
    int thingcount;
};

#endif // MANAGER_H
